/**********************************************
*  J[ZTgF
*   H\
*    White LED:RC5, RB7  Color LED:RB4,5,6
*    Color Sensor:RC3,4,6,7
**********************************************/
#include  <16f785.h>
// RtBM[V̐ݒ
#fuses INTRC_IO,NOWDT,NOPROTECT,PUT,BROWNOUT,MCLR,NOIESO,NOFCMEN
// foCX֘Aݒ
#use delay(CLOCK = 8000000)		// NbNg̒`
#use FAST_IO(A)					// I/ǑŒݒ
#use FAST_IO(B)
#use FAST_IO(C)
 /**** t\pݒ *****/
#define DB7 PIN_A4
#define DB6 PIN_A5
#define DB5 PIN_C0
#define DB4 PIN_A2
#define RS  PIN_A0
#define STB PIN_A1
#include <lcd_lib.c>				// t\CũCN[h
/**** J[ZTps` ****/
#define RANGE PIN_C4
#define GATE  PIN_C3
#define CK    PIN_C6
#define DATA  PIN_C7
/**** FLED̃s` ******/
#define White1 PIN_C5
#define White2 PIN_B7
/*** 萔Aϐ̐錾` ****/
static unsigned long Red, Green, Blue;
char StMsg[] = "Start!";
// ֐vg^CsO
unsigned long ColorIn(void);

/*********** C֐ **************/
void main(void)
{
	// o̓[hݒ
	set_tris_A(0x08);				// PORTA@MCLRȊOSo
	set_tris_B(0);				// ׂďo
	set_tris_C(0x80);				// RC7̂ݓ
	output_B(0xFF);				// lZbg
	output_C(0);
	// JnbZ[WLCD\
	lcd_init();
	lcd_clear();
	lcd_str(StMsg);
	delay_ms(500);				// 0.5bԕ\
	/********* C[v *************/
	while(1)
	{
		output_high(White1);		// FLEDI
		output_high(White2);
		delay_ms(100);			// 0.1b҂
		/**** J[ZT쓮 ****/
		output_high(RANGE);		// RangeIxI
		delay_ms(3);				// 3msec҂
		output_high(GATE);		// ϕJn@GateI
		delay_ms(100);			// 100msec
		output_low(GATE);			// ϕI@GateIt
		delay_us(10);				// 10usec҂
		Red = ColorIn();			// Red12rbg
		delay_us(10);				// 10usec҂
		Green = ColorIn();		// Green12rbg
		delay_us(10);				// 10usec҂
		Blue = ColorIn();			// Blue12rbg
		delay_ms(100);			// 100msec҂
		output_low(White1);		// FLEDIt
		output_low(White2);
		// t\퐧
		lcd_cmd(0x80);			// 1sڂɌo\
		printf(lcd_data, "Red  Green Blue");
		lcd_cmd(0xC0);			// t2sڂ3F̒l\
		printf(lcd_data, "%4Lu %4Lu  %4Lu", Red, Green, Blue); 
		delay_ms(1500);			// 1.5b҂
	}
}

/**********************************
*  J[ZTvsTu֐
*  12rbgVA
***********************************/
unsigned long ColorIn(void)
{
	int i, Value;
	unsigned long sData;

	sData = 0;					// f[^Zbg
	for(i=0; i<12; i++)			// 12rbgJԂ
	{
		output_high(CK);			// CKHigh
		Value = input(DATA);		// f[^1rbg
		output_low(CK);			// CKLow
		if(Value == 1)			// rbg`FbN
			bit_set(sData, i);	// 1̏ꍇ
		else
			bit_clear(sData, i);	// 0̏ꍇ
	}
	return(sData);				// 擾f[^Ԃ
}
 